property script_author : "Jonathan Nathan"
property script_name : "Installerish"
property script_version : "1.1"
property script_release_date_string : "10/1/2003"
property script_release_date : date script_release_date_string
property script_copyright : ("" & ((year of script_release_date) as string) & " " & script_author & ". All rights reserved.")

property color_black : {0, 0, 0}
property color_grey : {32767, 32767, 32767}
property color_red : {47726, 25121, 22867}
property color_green : {10036, 40247, 9553}

on will finish launching the_object
	set object_name to name of the_object as string
	my update_status("will finish launching " & object_name)
end will finish launching

on launched the_object
	my update_status("launched " & (name of the_object as string))
	activate
	show window "main"
end launched

on should quit after last window closed the_object
	return true
end should quit after last window closed

on awake from nib the_object
	set object_name to name of the_object as string
	my update_status("awake from nib " & object_name)
	if object_name = "main" then
		tell the_object
			center
		end tell
		
	else if object_name = "about" then
		tell the_object
			center
			set contents of text field "title" to (script_name & " v" & script_version)
			set contents of text field "author" to ("by " & script_author)
			set contents of text field "release" to ("Released " & script_release_date as string)
			set contents of text field "copyright" to (script_copyright)
		end tell
		
	end if
end awake from nib

on activated the_object
	set object_name to name of the_object as string
	my update_status("activated " & object_name)
end activated

on choose menu item the_object
	set object_name to name of the_object as string
	my update_status("choose menu item " & object_name)
	
	if object_name = "about" then
		show window "about"
		
	else if object_name = "quit" then
		quit
		
	end if
end choose menu item

on clicked the_object
	set object_name to name of the_object as string
	my update_status("clicked " & object_name)
	if object_name = "install" then
		set enabled of the_object to false
		tell window "main"
			tell matrix "step_matrix"
				set current row to 0
				set current column to 1
				set cell_count to count of cells
			end tell
			repeat with i from 1 to cell_count
				set current row of matrix "step_matrix" to i
				set enabled of cell i of matrix "step_matrix" to true
				--alt
				set text color of text field ("step_" & (i as string)) to color_black
				tell text field ("step_" & (i as string) & "_bullet")
					set text color to color_grey
					set content to "-"
				end tell
				my update_text(("I am now running step " & (i as string) & "..."), true)
				delay 1
				tell text field ("step_" & (i as string) & "_bullet")
					set text color to color_green
					set content to ""
				end tell
				my update_text(("I finished running step " & (i as string) & "." & return), true)
				delay 1
			end repeat
			my update_text(("I finished this process."), true)
			set enabled of button "reset" to true
		end tell
		
	else if object_name = "reset" then
		set enabled of the_object to false
		my update_text(("Press the Install button below to test the matrix code." & return), false)
		tell window "main"
			tell matrix "step_matrix"
				set state of every cell to off state
				set enabled of every cell to false
				set cell_count to count of cells
			end tell
			repeat with i from 1 to cell_count
				set text color of text field ("step_" & (i as string)) to color_grey
				set text color of text field ("step_" & (i as string) & "_bullet") to color_red
				tell text field ("step_" & (i as string) & "_bullet")
					set text color to color_red
					set content to ""
				end tell
			end repeat
			set enabled of button "install" to true
		end tell
		
	end if
end clicked

on update_text(the_string, append_string)
	my update_status("updating text")
	tell text view 1 of scroll view "log" of window "main"
		if append_string = false then
			set contents to the_string
		else
			set old_text to contents & return
			set contents to old_text & the_string
			set all_text to contents
			set the_length to (length of all_text)
			call method "scrollRangeToVisible:" of object it with parameter {the_length, the_length}
		end if
	end tell
end update_text

on update_status(the_message)
	log the_message
end update_status